/* http://keith-wood.name/flightBoard.html
   Flight Board for jQuery 2.0.0.
   Written by Keith Wood (kbwood{at}iinet.com.au) October 2009.
   Available under the MIT (https://github.com/jquery/jquery/blob/master/MIT-LICENSE.txt) license. 
   Please attribute the author if you use it. */
(function($){var p='flightboard';$.JQPlugin.createPlugin({name:p,defaultOptions:{lettersImage:'img/flightBoardLarge.png',lettersSize:[25,34],lettersSeq:' ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789',messages:['SEE THE FLIGHT BOARD','CHANGE MESSAGES'],maxLength:20,flips:[3,5],sequential:false,speed:500,repeat:true,pause:2000,selection:'forward',shading:true,opacity:0.5,shadingImages:['img/flightBoardHigh.png','img/flightBoardShad.png'],beforeFlip:null,afterFlip:null},_getters:['current','next'],_uuid:new Date().getTime(),_instSettings:function(a,b){return{_current:0,_next:0,_anims:[]}},_optionsChanged:function(a,b,c){this.stop(a[0],true);$.extend(b.options,c);var d=(b._dontReset?Math.min(b._current,b.options.messages.length-1):0);b._dontReset=false;$.extend(b,{_current:d,_next:d,_anims:[]});if(!a[0].id){a[0].id='fb'+this._uuid++}$('#'+a[0].id+'_css').remove();$('<style type="text/css" id="'+a[0].id+'_css">#'+a[0].id+' span { display: block; float: left; width: '+b.options.lettersSize[0]+'px; height: '+b.options.lettersSize[1]+'px; background: url('+b.options.lettersImage+') center no-repeat; }</style>').appendTo('head');var e='';var f=(b.options.messages[b._current]||'');for(var i=0;i<b.options.maxLength;i++){e+='<span style="background-position: -'+(Math.max(0,b.options.lettersSeq.indexOf(f.charAt(i)||' '))*b.options.lettersSize[0])+'px 0px;"></span>'}a.html(e);this._prepareFlip(a[0])},_preDestroy:function(a,b){this.stop(a[0]);a.empty();$('#'+a[0].id+'_css').remove()},current:function(a){var b=this._getInst(a);return($(a).hasClass(this._getMarker())?b.options.messages[b._current]:null)},next:function(a){var b=this._getInst(a);return($(a).hasClass(this._getMarker())?b.options.messages[b._next]:null)},stop:function(a,b){var c=this._getInst(a);if(c._timer){clearTimeout(c._timer);c._timer=null}for(var i=0;i<c._anims.length;i++){c._anims[i].stop().remove()}if(!b){c._dontReset=true;this.option(a,'repeat',false)}},start:function(a){var b=this._getInst(a);b._dontReset=true;this.option(a,'repeat',true)},_prepareFlip:function(a){var b=this._getInst(a);b._current=b._next;b._next=(b.options.selection==='random'?randInt(b.options.messages.length-1):(b.options.selection==='backward'?b._next+b.options.messages.length-1:b._next+1))%b.options.messages.length;b._next=(b.options.selection==='random'&&b._next===b._current?b.options.messages.length-1:b._next);if(b.options.repeat&&!b._timer){b._timer=setTimeout(function(){q.flip(a)},b.options.pause)}},flip:function(a,b){this.stop(a,true);var c=this._getInst(a);if(b!=null){if(b>=0&&b<=c.options.messages.length){c._next=b}}c._count=c.options.maxLength;if(c.options.beforeFlip&&$.isFunction(c.options.beforeFlip)){c.options.beforeFlip.apply(a,[c.options.messages[c._current],c.options.messages[c._next]])}c._anims=[];var d=c.options.messages[c._current];var b=c.options.messages[c._next];var e=$(a).offset();var f=($.isArray(c.options.flips)?c.options.flips:[c.options.flips,c.options.flips]);var g=this._charTemplate(c);for(var i=0;i<c.options.maxLength;i++){var h=g.clone().css({left:e.left+i*c.options.lettersSize[0],top:e.top}).appendTo('body');c._anims.push(h);var k=randInt(f[1]-f[0]+1)+f[0];var l='';if(c.options.sequential){var m=c.options.lettersSeq.indexOf(d.charAt(i)||' ');var n=c.options.lettersSeq.indexOf(b.charAt(i)||' ');l=(m<n?c.options.lettersSeq.substring(m,n+1):c.options.lettersSeq.substring(m)+c.options.lettersSeq.substring(0,n+1))}else{l=d.charAt(i)||' ';for(var j=1;j<k;j++){l+=c.options.lettersSeq.charAt(randInt(c.options.lettersSeq.length))}l+=b.charAt(i)||' '}var o=(!isNaN(c.options.speed)?c.options.speed:$.fx.speeds[c.options.speed]||$.fx.speeds._default);o=o*0.9+randInt(o*0.2);this._flipChar(a,h,c,$('span:eq('+i+')',a),l,o)}},_charTemplate:function(a){var b=a.options.lettersImage;var c=a.options.lettersSize[0];var d=a.options.lettersSize[1];var e=a.options.lettersSeq.length*c;var f='<div style="position: absolute; left: 0px; top: 0px; width: '+c+'px; height: '+d+'px;">'+'<div class="fbnt" style="position: absolute; width: '+c+'px; height: '+(d/2)+'px; overflow: hidden;">'+'<img src="'+b+'" style="position: relative; left: 0px; width: '+e+'px; height: '+d+'px; vertical-align: top;"></div>'+'<div class="fbob" style="position: absolute; top: '+(d/2)+'px; width: '+c+'px; height: '+(d/2)+'px; overflow: hidden;">'+'<img src="'+b+'" style="position: relative; left: 0px; top: -'+(d/2)+'px; width: '+e+'px; height: '+d+'px; vertical-align: top;"></div>'+'<div class="fbot" style="position: absolute; top: 0px; width: '+c+'px; height: '+(d/2)+'px; overflow: hidden;">'+'<img src="'+b+'" style="position: relative; left: 0px; width: '+e+'px; height: '+d+'px; vertical-align: top;"></div>'+'<div class="fbnb" style="position: absolute; top: '+(d/2)+'px; width: '+c+'px; height: 0px; overflow: hidden;"><img src="'+b+'" style="position: relative; left: 0px; top: 0px; width: '+e+'px; height: 0px; vertical-align: top;"></div>';if(a.options.shading){f+=(!$.support.opacity?'<img src="'+a.options.shadingImages[1]+'"':'<div')+' class="fbsh" style="position: absolute; width: '+c+'px; background-color: black; opacity: '+a.options.opacity+'; filter: alpha(opacity='+(a.options.opacity*100)+');"'+(!$.support.opacity?'/>':'></div>')+(!$.support.opacity?'<img src="'+a.options.shadingImages[0]+'"':'<div')+' class="fbhi" style="position: absolute; top: '+(d/2)+'px; width: '+c+'px; height: 0px; background-color: white; opacity: '+a.options.opacity+'; filter: alpha(opacity='+(a.options.opacity*100)+');"'+(!$.support.opacity?'/>':'></div>')}return $(f+'</div>')},_finishedChar:function(a){var b=this._getInst(a);b._count--;if(b._count===0){var c=[b.options.messages[b._current],b.options.messages[b._next]];this._prepareFlip(a);if(b.options.afterFlip&&$.isFunction(b.options.afterFlip)){b.options.afterFlip.apply(a,c)}}},_flipChar:function(a,b,c,d,e,f){if(e.length<2){b.remove().removeData(c.name);q._finishedChar(a);return}var g=c.options.lettersSize[0];var h=c.options.lettersSeq.indexOf(e.charAt(0));var i=c.options.lettersSeq.indexOf(e.charAt(1));var j=b[0].firstChild;$(j.firstChild).css('left',-i*g);j=j.nextSibling;$(j.firstChild).css('left',-h*g);j=j.nextSibling;$(j.firstChild).css('left',-h*g);j=j.nextSibling;$(j).css('height',0);$(j.firstChild).css('left',-i*g);b.data(c.name,{span:d,offset:-i*g}).animate({fbHeight:1},f,function(){q._flipChar(a,b,c,d,e.substring(1),f)})},_getStepProps:function(a){var b=[];var c=$(a).height();var d=a.children||a.childNodes;b[0]={elem:d[2],first:true,props:{top:{start:0,diff:c,units:'px',min:-999999},height:{start:c/2+1,diff:-c,units:'px',min:0}}};b[1]={elem:d[2].firstChild,first:true,props:{height:{start:c,diff:-2*c,units:'px',min:0}}};b[2]={elem:d[3],first:false,props:{height:{start:-c/2,diff:c,units:'px',min:0}}};b[3]={elem:d[3].firstChild,first:false,props:{top:{start:c/2,diff:-c,units:'px',min:-999999},height:{start:-c,diff:2*c,units:'px',min:0}}};if(d.length>4){var e=parseFloat($(d[4]).css('opacity'));b[4]={elem:d[4],first:true,props:{top:{start:0,diff:c,units:'px',min:-999999},height:{start:c/2+1,diff:-c,units:'px',min:0},opacity:{start:0,diff:2*e,units:'',min:0}}};b[5]={elem:d[5],first:false,props:{height:{start:-c/2,diff:c,units:'px',min:0},opacity:{start:2*e,diff:-2*e,units:'',min:0}}}}return b}});var q=$.flightboard;function randInt(a){return Math.floor(Math.random()*a)}$.fx.step['fbHeight']=function(a){if(!a.stepProps){a.stepProps=q._getStepProps(a.elem);a.first=true}for(var i=0;i<a.stepProps.length;i++){var b=a.stepProps[i];if(a.first===b.first){for(var c in b.props){var d=b.props[c];b.elem.style[c]=Math.max(a.pos*d.diff+d.start,d.min)+d.units;if(!$.support.opacity&&c==='opacity'){b.elem.style.filter='alpha(opacity='+(Math.max(a.pos*d.diff+d.start,d.min)*100)+')'}}}}if(a.first&&a.pos>=0.5){a.first=false}if(a.pos===1){var e=$.data(a.elem,p);if(e){e.span.css('background-position',e.offset+'px 0px')}}}})(jQuery);